net.sf.cpsolver.ifs.model

## Interface VariableListener<T extends Value<?,T>>

-     public interface VariableListener<T extends Value<?,T>>

  IFS variable listener.
  Version:
    IFS 1.2 (Iterative Forward Search)
    Copyright (C) 2006 - 2010 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  See Also:
    `Variable`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `valueRemoved(long iteration, T value)` Called by the variable when a value is permanently removed from its domain
    `void` | `variableAssigned(long iteration, T value)` Called by the variable when a value is assigned to it
    `void` | `variableUnassigned(long iteration, T value)` Called by the variable when a value is unassigned from it

- - ### Method Detail

    - #### variableAssigned

          void variableAssigned(long iteration,
                                T value)

      Called by the variable when a value is assigned to it
      Parameters:
        `iteration` - current iteration
        `value` - assigned to the variable

    - #### variableUnassigned

          void variableUnassigned(long iteration,
                                  T value)

      Called by the variable when a value is unassigned from it
      Parameters:
        `iteration` - current iteration
        `value` - unassigned from the variable

    - #### valueRemoved

          void valueRemoved(long iteration,
                            T value)

      Called by the variable when a value is permanently removed from its domain
      Parameters:
        `iteration` - current iteration
        `value` - removed from the variable's domain